package com.flyer.foster.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.flyer.foster.dto.GardenQueryDTO;
import com.flyer.foster.dto.GardenRespDTO;
import com.flyer.foster.entity.Garden;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 果园 Mapper 接口
 * </p>
 *
 * @author flyer
 * @since 2024-05-09
 */
public interface IGardenMapper extends BaseMapper<Garden> {

    /**
     * 物理删除
     * @param idList
     * @return
     */
    boolean deleteByIdList(@Param("idList") List<Integer> idList);

    /**
     * 果园列表-分页
     * @param page
     * @param queryDTO
     * @return
     */
    IPage<GardenRespDTO> getPageList(IPage<GardenRespDTO> page, GardenQueryDTO queryDTO);
}
