package com.flyer.foster.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.flyer.foster.dto.TreeAddDTO;
import com.flyer.foster.dto.TreeRespDTO;
import com.flyer.foster.entity.Tree;
import com.flyer.foster.mapper.ITreeMapper;
import com.flyer.foster.service.ITreeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 树 服务实现类
 * </p>
 *
 * @author flyer
 * @since 2024-05-09
 */
@Service
public class TreeServiceImpl extends ServiceImpl<ITreeMapper, Tree> implements ITreeService {

    @Override
    public Integer addTree(TreeAddDTO addDTO) {
        Tree tree = new Tree();
        BeanUtil.copyProperties(addDTO, tree);
        this.save(tree);
        return tree.getId();
    }

    @Override
    public boolean deleteByIdList(List<Integer> idList) {
        return baseMapper.deleteByIdList(idList);
    }

    @Override
    public List<TreeRespDTO> getTreeById(Integer gardenId) {
        return baseMapper.getTreeById(gardenId);
    }
}
