package com.flyer.util;

import io.jsonwebtoken.Jwts;
import io.jsonwebtoken.SignatureAlgorithm;
import org.apache.commons.codec.binary.Base64;
import org.springframework.stereotype.Component;

import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;
import java.util.Date;
import java.util.Map;

/**
 * JwtUtil
 *
 * @author kelei
 * @since 2022/3/25/10:32
 */
@Component
public class JwtUtil {
    /**
     * 使用jwt根据用户名生成token
     *
     * @return token
     */
    public String createBirdseyeToken(Map<String, Object> claims, String audience, String subject) {
        return Jwts.builder()
                .addClaims(claims)
                .setAudience(audience)
                .setSubject(subject)
                .setExpiration(new Date(System.currentTimeMillis() + 604800000))
                .signWith(SignatureAlgorithm.HS256, this.key()).compact();
    }

    private SecretKey key() {
        byte[] encodedKey = Base64.decodeBase64("fast-jwt");
        return new SecretKeySpec(encodedKey, 0, encodedKey.length, "AES");
    }
}
